<template>
  <div >
    <el-dialog :close-on-click-modal="false" v-loading="loadingFlash" element-loading-background="rgba(0,0,0,0.2)"
               v-dialogDrag :title="pdf.title"
               :visible.sync="pdf.open" width="1300px" :center="true" append-to-body>
      <div style="margin-top: -60px;float: right;margin-right: 40px;">
        <el-button size="mini" type="text" @click="openPdf">{{ $t('新页面打开PDF') }}</el-button>
      </div>
      <div style="margin-top: -30px">
        <iframe id="iFrame" class="iframe-html" :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px"
                v-if="ppt"></iframe>
      </div>
      <div style="padding: 30px; width: 100%; height: 100%;">
        <el-carousel class="" ref="carousel" arrow="always" v-if="pptView"
                     height="700px" trigger="click" :autoplay="false" indicator-position="outside">
          <el-carousel-item class="lun_img" v-for="item in imgs" v-bind:key="item">
            <img :src="item" width="100%" height="100%" object-fit="cover"/>
          </el-carousel-item>
        </el-carousel>
      </div>
    </el-dialog>
  </div>

</template>
<script>


export default {

  data() {
    return {
      imgs:[],
      pptView:false,
      ppt: false,
      loadingFlash: null,
      pdf: {
        title: '',
        pdfUrl: '',
        numPages: null,
        open: false,
        pageNum: 1,
        pageTotalNum: 1,
        loadedRatio: 0,
      },
    }
  },
  mounted() {
  },

  methods: {
    handleSee(fileName, url) {
      //office预览
      this.loadingFlash = true
      this.pdf.open = true
      this.pdf.title = fileName
      this.pdf.pdfUrl = ""
      this.pptView = false
      this.ppt = true
      //如果是PDF等直接可以打开的就不调接口，否则调用接口
      if (fileName.endsWith('pdf')) {
        this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + url
        this.loadingFlash = false
      } else {
        const formatDate = new FormData();
        formatDate.append("filepath", url)
        //调用文件预览api
        let res = this.officeConvert.bookConvertCommon(formatDate)
        //查看接受全局方法的返回结果 console.log(res)
        //利用.then方法接受Promise对象
        res.then((result) => {
          //关闭加载中
          this.loadingFlash = false
          if (result.msg.includes("csv")) {
            this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + result.data
            this.$alert(result.msg, this.$t('检查乱码'), {dangerouslyUseHTMLString: true});
            //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
          } else if (result.msg.includes("不存在")) {
            //文件不存在时提示
            this.pdf.pdfUrl = ""
            this.$alert(result.msg, this.$t('预览失败'), {dangerouslyUseHTMLString: true});
            //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
            this.pdf.open = false
          } else if (result.msg.includes("不支持此格式")) {
            this.pdf.pdfUrl = ""
            this.$alert(result.msg, this.$t('预览失败'), {dangerouslyUseHTMLString: true});
            //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
            this.pdf.open = false
          } else {
            //成功时直接给地址
            this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + result.data
          }
        }).catch(result => {
          //请求失败，关闭loading，pdf地址直接为为空，不显示
          this.pdf.pdfUrl = ""
          this.loadingFlash = false;
        })
      }
    },
    //文件预览
    openPdf() {
      //ppt就跳路由预览，office就直接打开文件新页面
      const didi = {imgs: this.imgs}
      if (this.pptView == true && this.ppt == false) {
        let routeUrl = this.$router.resolve({
          path: "/cpms/index.html#/pptyulan",
          query: didi
        });
        window.open("/cpms/index.html#/pptyulan?id=" + this.pdf.pdfUrl, '_blank')
        console.log(this.imgs)
      } else {
        window.open(this.pdf.pdfUrl)
      }
    },
  }
}
</script>
